# Notes about using Windows and WSL2


## Windows

Windows desktop docker and WSL2 and Ubuntu with ros needs to be installed.

### ROS

We recommend that you install ROS in WSL2 Ubuntu in Windows. See:

https://jack-kawell.com/2020/06/12/ros-wsl2/

Make sure that X is working and that rviz can be started.

### Ubuntu (WSL2) - SSH

In Ubuntu do:
```bash
sudo apt install openssh-server
ssh-keygen
cd /etc/ssh
sudo ssh-keygen -A
cd
# set password authentication to on in /etc/ssh/sshd_config
# this means open the file in a text editor and change the line that looks like
#      PasswordAuthentication no
# and change the no to a yes
sudo service ssh start
```

The server needs to be started for ansible installation.

The follow the setup for SSH in: https://gitlab.liu.se/lrs/lrs_devenv_common/-/blob/master/doc/install_playbooks.md#setting-up-ssh

### Docker on Windows

Follow the instructions here:

https://docs.docker.com/docker-for-windows/wsl/

In an Ubuntu shell install docker.io:
```bash
sudo apt install docker.io
```

Then after starting the docker server from the desktop app you can do:
```bash
docker ps
```

### Setup

Additional packages:
```bash
sudo apt install python3-vcstool python3-catkin-tools python3-osrf-pycommon ros-noetic-geographic-msgs python3-pyproj ansible mosquitto-clients ros-noetic-nmea-msgs
```

jsoncons:
```bash
cd /opt
sudo git clone https://github.com/danielaparker/jsoncons.git
```

Ansible:
```bash
mkdir src
cd src
git clone https://gitlab.liu.se/lrs/lrs_playbooks.git
cd lrs_playbooks
```

Ansible command:
```bash
ansible-playbook -i hosts playbooks/wara_develop.yml -e user=${USER} -e install_user=${USER} -e ansible_sudo_pass=****** --tags packages,djisdk,paho,copyimage,lrs_devenv_common,repos,sdk,warabuild
```

Set up path and other stuff according to:

https://gitlab.liu.se/lrs/lrs_devenv_common/-/blob/master/doc/install_playbooks.md#finishing-up
